#!/usr/bin/env node

const path = require('path')
const fs = require('fs')
const minimist = require('minimist')
const getTmp = require('../libs/getTemplate')
const args = minimist(process.argv.slice(2))
console.log('args:', args)
if (args.o && typeof args.o == 'string') {
  let fpath = ''

  const currentPath = path.resolve()
  if (!args.o.match('^((/[a-zA-Z0-9-_]+)+|/)$')) {
    console.log('路径输入错误  请按照如下格式:/pages/XXX/XXX/name')
    return;
  }
  // if (args.o.substr(-1) === '/') {
  //   args.o = args.o.substr(0, args.o.length - 1)
  // }
  const pagePath = args.o

  if (pagePath[0] === '/') {
    fpath = currentPath + path.dirname(pagePath)
  } else {
    fpath = currentPath + '/' + path.dirname(pagePath)
  }
  const fileName = path.basename(pagePath);
  console.log('fileName:', fileName)

  console.log('fpath:', fpath)

  if (!fs.existsSync(fpath)) {
    mkdirsSync(fpath) // 创建目录

    let wxssContent = getTmp.getTemplate('wechatcmp.wxss')
    // console.log('wxssContent:', wxssContent)
    fs.writeFileSync(path.join(fpath, `${fileName}.wxss`), `/*${pagePath}.wsss*/\n${wxssContent}`);

    let jsContent = getTmp.getTemplate('wechatcmp.js')
    fs.writeFileSync(path.join(fpath, `${fileName}.js`), `//${pagePath}.js\n${jsContent}`);

    let jsonContent = getTmp.getTemplate('wechatcmp.json')
    fs.writeFileSync(path.join(fpath, `${fileName}.json`), `${jsonContent}`);

    let wxmlContent = getTmp.getTemplate('wechatcmp.wxml')
    fs.writeFileSync(path.join(fpath, `${fileName}.wxml`), `<!--${pagePath}.wxml-->\n${wxmlContent}`);


  } else {
    console.log(`${fpath} 已存在`)
  }

} else {
  console.log('请在工程的根目录下输入要创建的路径,格式为 npx wxpath -o /components/test/test')
}


function mkdirsSync(dirname) {
  if (fs.existsSync(dirname)) {
    return true;
  } else {
    if (mkdirsSync(path.dirname(dirname))) {
      fs.mkdirSync(dirname);
      return true;
    }
  }
}